/************************************************************************************
 * Copyright (C) 2018 ALTIMA Company MACNICA, Inc. All Rights Reserved.\n
 *   This software is licensed "AS IS". 
 *   Please perform use of this software by a user's own responsibility and expense.
 *   It cannot guarantee in the maker side about the damage which occurred by the ab-
 *   ility not to use or use this software, and all damage that occurred secondarily.
 ***********************************************************************************/

#ifndef APP_PCI_H_
#define APP_PCI_H_

#define	_KB		1024UL
#define	_MB		(1024UL*1024UL)
#define	_GB		(1024UL*1024UL*1024UL)

#define BAR0_OCRAM_BASE    (0x7000000)
#define BAR0_OCRAM_SIZE    (512 * _KB)
#define BAR0_DDR_MEM_BASE  (0x8000000)
#define BAR0_DDR_MEM_SIZE  (32 * _MB)
#define BAR2_LED_PIO_BASE  (0x4000)
#define BAR2_DMA_CSR_BASE  (0x6000000)
#define BAR2_DMA_DESC_BASE (0x6000040)

#define BAR0 (0)
#define BAR1 (1)
#define BAR2 (2)
#define BAR3 (3)
#define BAR4 (4)
#define BAR5 (5)

/* PCI Config 0 Space Map */
#define PCI_CONFIG_0_D_ID_V_ID                (0x00)
#define PCI_CONFIG_0_STATUS_CMD               (0x04)
#define PCI_CONFIG_0_CLASS_REV_ID             (0x08)
#define PCI_CONFIG_0_BIST_HEAD_TIMER_CACHE    (0x0C)
#define PCI_CONFIG_0_BAR0                     (0x10)
#define PCI_CONFIG_0_BAR1                     (0x14)
#define PCI_CONFIG_0_BAR2                     (0x18)
#define PCI_CONFIG_0_BAR3                     (0x1C)
#define PCI_CONFIG_0_BAR4                     (0x20)
#define PCI_CONFIG_0_BAR5                     (0x24)
#define PCI_CONFIG_0_CIS_PTR                  (0x28)
#define PCI_CONFIG_0_SUBSYS_ID_VID            (0x2C)
#define PCI_CONFIG_0_EXT_ROM_ADDR             (0x30)
#define PCI_CONFIG_0_CAP_PTR                  (0x34)
#define PCI_CONFIG_0_RESERVED                 (0x38)
#define PCI_CONFIG_0_IRQ                      (0x3C)

/* PCI Config 1 Space Map */
#define PCI_CONFIG_1_D_ID_V_ID                (0x00)
#define PCI_CONFIG_1_STATUS_CMD               (0x04)
#define PCI_CONFIG_1_CLASS_REV_ID             (0x08)
#define PCI_CONFIG_1_BIST_HEAD_TIMER_CACHE    (0x0C)
#define PCI_CONFIG_1_BAR0                     (0x10)
#define PCI_CONFIG_1_BAR1                     (0x14)
#define PCI_CONFIG_1_BUS_NUM                  (0x18)
#define PCI_CONFIG_1_IO_BASE_LIMIT            (0x1C)
#define PCI_CONFIG_1_MEM_BASE_LIMIT           (0x20)
#define PCI_CONFIG_1_PREFETCH_MEM_BASE_LIMIT  (0x24)
#define PCI_CONFIG_1_PREFETCH_BASE_UPPER      (0x28)
#define PCI_CONFIG_1_PREFETCH_LIMIT_UPPER     (0x2C)
#define PCI_CONFIG_1_IO_BASE_LIMIT_UPPER      (0x30)
#define PCI_CONFIG_1_RESERVED                 (0x34)
#define PCI_CONFIG_1_EXT_ROM_ADDR             (0x38)
#define PCI_CONFIG_1_BRIDGE_CTL_IRQ           (0x3C)

#define MEM_SPACE_ENA                         (1 << 1) //CMD bit1
#define BUS_MST_ENA                           (1 << 2) //CMD bit2

#define LINK_CTL_RETRAIN_BIT                  (1 << 5)

#define CONFIG_SPACE_SIZE (0x40)

int root_pci_config_space_dump(void);
int end_pci_config_space_dump(void);
int config_read(unsigned int target, unsigned int offset, unsigned int *data);
int config_write(unsigned int target, unsigned int offset, unsigned int data);
int barX_read(unsigned int bar_num, unsigned int offset, unsigned int *data);
int barX_write(unsigned int bar_num, unsigned int offset, unsigned int data);
unsigned int *map_bar(unsigned int bar_num, unsigned int offset, unsigned int size);

#endif /* APP_PCI_H_ */
